EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_SPOTLIGHT_EVENT_TRANSITION_START =
   EFL_EVENT_DESCRIPTION("transition,start");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_SPOTLIGHT_EVENT_TRANSITION_END =
   EFL_EVENT_DESCRIPTION("transition,end");

void _efl_ui_spotlight_container_spotlight_manager_set(Eo *obj, Efl_Ui_Spotlight_Container_Data *pd, Efl_Ui_Spotlight_Manager *spotlight_manager);

static void
_efl_ui_spotlight_manager_set_ownership_fallback(Efl_Ui_Spotlight_Manager *spotlight_manager)
{
   efl_del(spotlight_manager);
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV_FALLBACK(efl_ui_spotlight_manager_set, _efl_ui_spotlight_manager_set_ownership_fallback(spotlight_manager);, EFL_FUNC_CALL(spotlight_manager), Efl_Ui_Spotlight_Manager *spotlight_manager);

Efl_Ui_Spotlight_Manager *_efl_ui_spotlight_container_spotlight_manager_get(const Eo *obj, Efl_Ui_Spotlight_Container_Data *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_spotlight_manager_get, Efl_Ui_Spotlight_Manager *, NULL);

void _efl_ui_spotlight_container_indicator_set(Eo *obj, Efl_Ui_Spotlight_Container_Data *pd, Efl_Ui_Spotlight_Indicator *indicator);

static void
_efl_ui_spotlight_indicator_set_ownership_fallback(Efl_Ui_Spotlight_Indicator *indicator)
{
   efl_del(indicator);
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV_FALLBACK(efl_ui_spotlight_indicator_set, _efl_ui_spotlight_indicator_set_ownership_fallback(indicator);, EFL_FUNC_CALL(indicator), Efl_Ui_Spotlight_Indicator *indicator);

Efl_Ui_Spotlight_Indicator *_efl_ui_spotlight_container_indicator_get(const Eo *obj, Efl_Ui_Spotlight_Container_Data *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_spotlight_indicator_get, Efl_Ui_Spotlight_Indicator *, NULL);

void _efl_ui_spotlight_container_active_element_set(Eo *obj, Efl_Ui_Spotlight_Container_Data *pd, Efl_Ui_Widget *element);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_spotlight_active_element_set, EFL_FUNC_CALL(element), Efl_Ui_Widget *element);

Efl_Ui_Widget *_efl_ui_spotlight_container_active_element_get(const Eo *obj, Efl_Ui_Spotlight_Container_Data *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_spotlight_active_element_get, Efl_Ui_Widget *, NULL);

void _efl_ui_spotlight_container_spotlight_size_set(Eo *obj, Efl_Ui_Spotlight_Container_Data *pd, Eina_Size2D size);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_spotlight_size_set, EFL_FUNC_CALL(size), Eina_Size2D size);

Eina_Size2D _efl_ui_spotlight_container_spotlight_size_get(const Eo *obj, Efl_Ui_Spotlight_Container_Data *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_spotlight_size_get, Eina_Size2D, ((Eina_Size2D){0}));

void _efl_ui_spotlight_container_animated_transition_set(Eo *obj, Efl_Ui_Spotlight_Container_Data *pd, Eina_Bool enable);


static Eina_Error
__eolian_efl_ui_spotlight_container_animated_transition_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_ui_spotlight_animated_transition_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_spotlight_animated_transition_set, EFL_FUNC_CALL(enable), Eina_Bool enable);

Eina_Bool _efl_ui_spotlight_container_animated_transition_get(const Eo *obj, Efl_Ui_Spotlight_Container_Data *pd);


static Eina_Value
__eolian_efl_ui_spotlight_container_animated_transition_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_ui_spotlight_animated_transition_get(obj);
   return eina_value_bool_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_spotlight_animated_transition_get, Eina_Bool, 0);

void _efl_ui_spotlight_container_push(Eo *obj, Efl_Ui_Spotlight_Container_Data *pd, Efl_Gfx_Entity *widget);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_spotlight_push, EFL_FUNC_CALL(widget), Efl_Gfx_Entity *widget);

Eina_Future *_efl_ui_spotlight_container_pop(Eo *obj, Efl_Ui_Spotlight_Container_Data *pd, Eina_Bool deletion_on_transition_end);

EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_ui_spotlight_pop, Eina_Future *, NULL, EFL_FUNC_CALL(deletion_on_transition_end), Eina_Bool deletion_on_transition_end);

Efl_Object *_efl_ui_spotlight_container_efl_object_constructor(Eo *obj, Efl_Ui_Spotlight_Container_Data *pd);


Efl_Object *_efl_ui_spotlight_container_efl_object_finalize(Eo *obj, Efl_Ui_Spotlight_Container_Data *pd);


void _efl_ui_spotlight_container_efl_object_invalidate(Eo *obj, Efl_Ui_Spotlight_Container_Data *pd);


int _efl_ui_spotlight_container_efl_container_content_count(Eo *obj, Efl_Ui_Spotlight_Container_Data *pd);


Eina_Iterator *_efl_ui_spotlight_container_efl_container_content_iterate(Eo *obj, Efl_Ui_Spotlight_Container_Data *pd);


Eina_Bool _efl_ui_spotlight_container_efl_pack_pack_clear(Eo *obj, Efl_Ui_Spotlight_Container_Data *pd);


Eina_Bool _efl_ui_spotlight_container_efl_pack_unpack_all(Eo *obj, Efl_Ui_Spotlight_Container_Data *pd);


Eina_Bool _efl_ui_spotlight_container_efl_pack_unpack(Eo *obj, Efl_Ui_Spotlight_Container_Data *pd, Efl_Gfx_Entity *subobj);


Eina_Bool _efl_ui_spotlight_container_efl_pack_pack(Eo *obj, Efl_Ui_Spotlight_Container_Data *pd, Efl_Gfx_Entity *subobj);


Eina_Bool _efl_ui_spotlight_container_efl_pack_linear_pack_begin(Eo *obj, Efl_Ui_Spotlight_Container_Data *pd, Efl_Gfx_Entity *subobj);


Eina_Bool _efl_ui_spotlight_container_efl_pack_linear_pack_end(Eo *obj, Efl_Ui_Spotlight_Container_Data *pd, Efl_Gfx_Entity *subobj);


Eina_Bool _efl_ui_spotlight_container_efl_pack_linear_pack_before(Eo *obj, Efl_Ui_Spotlight_Container_Data *pd, Efl_Gfx_Entity *subobj, const Efl_Gfx_Entity *existing);


Eina_Bool _efl_ui_spotlight_container_efl_pack_linear_pack_after(Eo *obj, Efl_Ui_Spotlight_Container_Data *pd, Efl_Gfx_Entity *subobj, const Efl_Gfx_Entity *existing);


Eina_Bool _efl_ui_spotlight_container_efl_pack_linear_pack_at(Eo *obj, Efl_Ui_Spotlight_Container_Data *pd, Efl_Gfx_Entity *subobj, int index);


Efl_Gfx_Entity *_efl_ui_spotlight_container_efl_pack_linear_pack_content_get(Eo *obj, Efl_Ui_Spotlight_Container_Data *pd, int index);


int _efl_ui_spotlight_container_efl_pack_linear_pack_index_get(Eo *obj, Efl_Ui_Spotlight_Container_Data *pd, const Efl_Gfx_Entity *subobj);


Efl_Gfx_Entity *_efl_ui_spotlight_container_efl_pack_linear_pack_unpack_at(Eo *obj, Efl_Ui_Spotlight_Container_Data *pd, int index);


void _efl_ui_spotlight_container_efl_canvas_group_group_calculate(Eo *obj, Efl_Ui_Spotlight_Container_Data *pd);


static Eina_Bool
_efl_ui_spotlight_container_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_UI_SPOTLIGHT_CONTAINER_EXTRA_OPS
#define EFL_UI_SPOTLIGHT_CONTAINER_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_ui_spotlight_manager_set, _efl_ui_spotlight_container_spotlight_manager_set),
      EFL_OBJECT_OP_FUNC(efl_ui_spotlight_manager_get, _efl_ui_spotlight_container_spotlight_manager_get),
      EFL_OBJECT_OP_FUNC(efl_ui_spotlight_indicator_set, _efl_ui_spotlight_container_indicator_set),
      EFL_OBJECT_OP_FUNC(efl_ui_spotlight_indicator_get, _efl_ui_spotlight_container_indicator_get),
      EFL_OBJECT_OP_FUNC(efl_ui_spotlight_active_element_set, _efl_ui_spotlight_container_active_element_set),
      EFL_OBJECT_OP_FUNC(efl_ui_spotlight_active_element_get, _efl_ui_spotlight_container_active_element_get),
      EFL_OBJECT_OP_FUNC(efl_ui_spotlight_size_set, _efl_ui_spotlight_container_spotlight_size_set),
      EFL_OBJECT_OP_FUNC(efl_ui_spotlight_size_get, _efl_ui_spotlight_container_spotlight_size_get),
      EFL_OBJECT_OP_FUNC(efl_ui_spotlight_animated_transition_set, _efl_ui_spotlight_container_animated_transition_set),
      EFL_OBJECT_OP_FUNC(efl_ui_spotlight_animated_transition_get, _efl_ui_spotlight_container_animated_transition_get),
      EFL_OBJECT_OP_FUNC(efl_ui_spotlight_push, _efl_ui_spotlight_container_push),
      EFL_OBJECT_OP_FUNC(efl_ui_spotlight_pop, _efl_ui_spotlight_container_pop),
      EFL_OBJECT_OP_FUNC(efl_constructor, _efl_ui_spotlight_container_efl_object_constructor),
      EFL_OBJECT_OP_FUNC(efl_finalize, _efl_ui_spotlight_container_efl_object_finalize),
      EFL_OBJECT_OP_FUNC(efl_invalidate, _efl_ui_spotlight_container_efl_object_invalidate),
      EFL_OBJECT_OP_FUNC(efl_content_count, _efl_ui_spotlight_container_efl_container_content_count),
      EFL_OBJECT_OP_FUNC(efl_content_iterate, _efl_ui_spotlight_container_efl_container_content_iterate),
      EFL_OBJECT_OP_FUNC(efl_pack_clear, _efl_ui_spotlight_container_efl_pack_pack_clear),
      EFL_OBJECT_OP_FUNC(efl_pack_unpack_all, _efl_ui_spotlight_container_efl_pack_unpack_all),
      EFL_OBJECT_OP_FUNC(efl_pack_unpack, _efl_ui_spotlight_container_efl_pack_unpack),
      EFL_OBJECT_OP_FUNC(efl_pack, _efl_ui_spotlight_container_efl_pack_pack),
      EFL_OBJECT_OP_FUNC(efl_pack_begin, _efl_ui_spotlight_container_efl_pack_linear_pack_begin),
      EFL_OBJECT_OP_FUNC(efl_pack_end, _efl_ui_spotlight_container_efl_pack_linear_pack_end),
      EFL_OBJECT_OP_FUNC(efl_pack_before, _efl_ui_spotlight_container_efl_pack_linear_pack_before),
      EFL_OBJECT_OP_FUNC(efl_pack_after, _efl_ui_spotlight_container_efl_pack_linear_pack_after),
      EFL_OBJECT_OP_FUNC(efl_pack_at, _efl_ui_spotlight_container_efl_pack_linear_pack_at),
      EFL_OBJECT_OP_FUNC(efl_pack_content_get, _efl_ui_spotlight_container_efl_pack_linear_pack_content_get),
      EFL_OBJECT_OP_FUNC(efl_pack_index_get, _efl_ui_spotlight_container_efl_pack_linear_pack_index_get),
      EFL_OBJECT_OP_FUNC(efl_pack_unpack_at, _efl_ui_spotlight_container_efl_pack_linear_pack_unpack_at),
      EFL_OBJECT_OP_FUNC(efl_canvas_group_calculate, _efl_ui_spotlight_container_efl_canvas_group_group_calculate),
      EFL_UI_SPOTLIGHT_CONTAINER_EXTRA_OPS
   );
   opsp = &ops;

   static const Efl_Object_Property_Reflection refl_table[] = {
      {"animated_transition", __eolian_efl_ui_spotlight_container_animated_transition_set_reflect, __eolian_efl_ui_spotlight_container_animated_transition_get_reflect},
   };
   static const Efl_Object_Property_Reflection_Ops rops = {
      refl_table, EINA_C_ARRAY_LENGTH(refl_table)
   };
   ropsp = &rops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_ui_spotlight_container_class_desc = {
   EO_VERSION,
   "Efl.Ui.Spotlight.Container",
   EFL_CLASS_TYPE_REGULAR,
   sizeof(Efl_Ui_Spotlight_Container_Data),
   _efl_ui_spotlight_container_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_ui_spotlight_container_class_get, &_efl_ui_spotlight_container_class_desc, EFL_UI_WIDGET_CLASS, EFL_PACK_LINEAR_INTERFACE, NULL);
